Exiv2: Exiv2::CiffComponent Class Reference

- Main Page
- Namespaces
- Classes
- Files
- Examples

- Search for |

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Exiv2::CiffComponent Class Reference

Interface class for components of the CIFF directory hierarchy of a Crw (Canon Raw data) image. Both CIFF directories as well as entries implement this interface. This class is implemented as NVI (non-virtual interface). More...

`#include <crwimage.hpp>`

Inheritance diagram for Exiv2::CiffComponent:

[legend]

List of all members.

## Public Types
typedef std::auto_ptr < CiffComponent > | AutoPtr
| CiffComponent auto_ptr type.
typedef std::vector < CiffComponent * > | Components
| Container type to hold all metadata.
## Public Member Functions
Creators
| CiffComponent ()
| Default constructor.
| CiffComponent (uint16_t tag, uint16_t dir)
| Constructor taking a tag and directory.
virtual | ~CiffComponent ()
| Virtual destructor.
Manipulators
void | add (AutoPtr component)
| Add a component to the composition.
CiffComponent * | add (CrwDirs &crwDirs, uint16_t crwTagId)
| Add crwTagId to the parse tree, if it doesn't exist yet. crwDirs contains the path of subdirectories, starting with the root directory, leading to crwTagId. Directories that don't exist yet are added along the way. Returns a pointer to the newly added component.
void | remove (CrwDirs &crwDirs, uint16_t crwTagId)
| Remove crwTagId from the parse tree, if it exists yet. crwDirs contains the path of subdirectories, starting with the root directory, leading to crwTagId.
void | read (const byte *pData, uint32_t size, uint32_t start, ByteOrder byteOrder)
| Read a component from a data buffer.
uint32_t | write (Blob &blob, ByteOrder byteOrder, uint32_t offset)
| Write the metadata from the raw metadata component to the binary image blob. This method may append to the blob.
uint32_t | writeValueData (Blob &blob, uint32_t offset)
| Writes the entry's value if size is larger than eight bytes. If needed, the value is padded with one 0 byte to make the number of bytes written to the blob even. The offset of the component is set to the offset passed in.
void | setDir (uint16_t dir)
| Set the directory tag for this component.
void | setValue (DataBuf buf)
| Set the data value of the entry.
Accessors
void | decode (Image &image, ByteOrder byteOrder) const
| Decode metadata from the component and add it to image.
void | print (std::ostream &os, ByteOrder byteOrder, const std::string &prefix="") const
| Print debug info about a component to os.
void | writeDirEntry (Blob &blob, ByteOrder byteOrder) const
| Write a directory entry for the component to the blob. If the size of the data is not larger than 8 bytes, the data is written to the directory entry.
uint16_t | dir () const
| Return the tag of the directory containing this component.
uint16_t | tag () const
| Return the tag of this component.
bool | empty () const
| Return true if the component is empty, else false.
uint32_t | size () const
| Return the data size of this component.
uint32_t | offset () const
| Return the offset to the data from the start of the directory.
const byte * | pData () const
| Return a pointer to the data area of this component.
uint16_t | tagId () const
| Return the tag id of this component.
TypeId | typeId () const
| Return the type id of thi component.
DataLocId | dataLocation () const
| Return the data location for this component.
CiffComponent * | findComponent (uint16_t crwTagId, uint16_t crwDir) const
| Finds crwTagId in directory crwDir, returning a pointer to the component or 0 if not found.
## Static Public Member Functions
static TypeId | typeId (uint16_t tag)
| Return the type id for a tag.
static DataLocId | dataLocation (uint16_t tag)
| Return the data location id for a tag.
## Protected Member Functions
Manipulators
virtual void | doAdd (AutoPtr component)=0
| Implements add().
virtual CiffComponent * | doAdd (CrwDirs &crwDirs, uint16_t crwTagId)
| Implements add(). The default implementation does nothing.
virtual void | doRemove (CrwDirs &crwDirs, uint16_t crwTagId)
| Implements remove(). The default implementation does nothing.
virtual void | doRead (const byte *pData, uint32_t size, uint32_t start, ByteOrder byteOrder)
| Implements read(). The default implementation reads a directory entry.
virtual uint32_t | doWrite (Blob &blob, ByteOrder byteOrder, uint32_t offset)=0
| Implements write().
void | setSize (uint32_t size)
| Set the size of the data area.
void | setOffset (uint32_t offset)
| Set the offset for this component.
Accessors
virtual void | doDecode (Image &image, ByteOrder byteOrder) const =0
| Implements decode().
virtual void | doPrint (std::ostream &os, ByteOrder byteOrder, const std::string &prefix) const
| Implements print(). The default implementation prints the entry.
virtual bool | doEmpty () const
| Implements empty(). Default implementation returns true if size is 0.
virtual CiffComponent * | doFindComponent (uint16_t crwTagId, uint16_t crwDir) const
| Implements findComponent(). The default implementation checks the entry.

## Detailed Description

Interface class for components of the CIFF directory hierarchy of a Crw (Canon Raw data) image. Both CIFF directories as well as entries implement this interface. This class is implemented as NVI (non-virtual interface).

## Member Function Documentation

CiffComponent * Exiv2::CiffComponent::add | ( | CrwDirs & | crwDirs,
|  | uint16_t | crwTagId |
| ) |  |  |

Add crwTagId to the parse tree, if it doesn't exist yet. crwDirs contains the path of subdirectories, starting with the root directory, leading to crwTagId. Directories that don't exist yet are added along the way. Returns a pointer to the newly added component.

Parameters:

  | crwDirs | Subdirectory path from root to the subdirectory containing the tag to be added.
  | crwTagId | Tag to be added.

Returns:
  A pointer to the newly added component.

void Exiv2::CiffComponent::remove | ( | CrwDirs & | crwDirs,
|  | uint16_t | crwTagId |
| ) |  |  |

Remove crwTagId from the parse tree, if it exists yet. crwDirs contains the path of subdirectories, starting with the root directory, leading to crwTagId.

Parameters:

  | crwDirs | Subdirectory path from root to the subdirectory containing the tag to be removed.
  | crwTagId | Tag to be removed.

void Exiv2::CiffComponent::read | ( | const byte * | pData,
|  | uint32_t | size,
|  | uint32_t | start,
|  | ByteOrder | byteOrder |
| ) |  |  |

Read a component from a data buffer.

Parameters:

  | pData | Pointer to the data buffer.
  | size | Number of bytes in the data buffer.
  | start | Component starts at pData + start.
  | byteOrder | Applicable byte order (little or big endian).

Exceptions:

  | Error | If the component cannot be parsed.

uint32_t Exiv2::CiffComponent::write | ( | Blob & | blob,
|  | ByteOrder | byteOrder,
|  | uint32_t | offset |
| ) |  |  |

Write the metadata from the raw metadata component to the binary image blob. This method may append to the blob.

Parameters:

  | blob | Binary image to add metadata to
  | byteOrder | Byte order
  | offset | Current offset

Returns:
  New offset

uint32_t Exiv2::CiffComponent::writeValueData | ( | Blob & | blob,
|  | uint32_t | offset |
| ) |  |  |

Writes the entry's value if size is larger than eight bytes. If needed, the value is padded with one 0 byte to make the number of bytes written to the blob even. The offset of the component is set to the offset passed in.

Parameters:

  | blob | The binary image to write to.
  | offset | Offset from the start of the directory for this entry.

Returns:
  New offset.

void Exiv2::CiffComponent::decode | ( | Image & | image,
|  | ByteOrder | byteOrder |
| ) |  |  | const

Decode metadata from the component and add it to image.

Parameters:

  | image | Image to add metadata to
  | byteOrder | Byte order

void Exiv2::CiffComponent::print | ( | std::ostream & | os,
|  | ByteOrder | byteOrder,
|  | const std::string & | prefix = `""` |
| ) |  |  | const

Print debug info about a component to os.

Parameters:

  | os | Output stream to write to
  | byteOrder | Byte order
  | prefix | Prefix to be written before each line of output

uint32_t Exiv2::CiffComponent::size | ( |  | ) | const`[inline]`

Return the data size of this component.

Note:
  If the data is contained in the directory entry itself, this method returns 8, which is the maximum number of data bytes this component can have. The actual size, i.e., used data bytes, may be less than 8.

The documentation for this class was generated from the following files:

- crwimage.hpp
- crwimage.cpp